Eio Reference helper API

- Main Page
- Related Pages
- Modules
- Data Structures
- Files
- Examples

Functions
Eio Reference helper API
Eio

This are helper provided around core Eio API. More...

## Functions
static double | eio_file_atime (const Eina_Stat *st)
| Return last access time to a file.
static double | eio_file_mtime (const Eina_Stat *st)
| Return last modification time of a file.
static long long | eio_file_size (const Eina_Stat *st)
| Return file length.
static Eina_Bool | eio_file_is_dir (const Eina_Stat *st)
| Return if path is a directory.
static Eina_Bool | eio_file_is_lnk (const Eina_Stat *st)
| Return if path is a length.
EIO_API int | eio_init (void)
| Initialize eio and all its required submodule.
EIO_API int | eio_shutdown (void)
| Shutdown eio and all its submodule if possible.
EIO_API void | eio_memory_burst_limit_set (size_t limit)
| Set the limit to the maximum amount of memory used.
EIO_API size_t | eio_memory_burst_limit_get (void)
| Get the actual limit to the maximum amount of memory used.
EIO_API void * | eio_file_container_get (Eio_File *ls)
| Return the container during EIO operation.
EIO_API Eina_Bool | eio_file_cancel (Eio_File *ls)
| Cancel any Eio_File.
EIO_API Eina_Bool | eio_file_check (Eio_File *ls)
| Check if an Eio_File operation has been cancelled.
EIO_API Eina_Bool | eio_file_associate_add (Eio_File *ls, const char *key, const void *data, Eina_Free_Cb free_cb)
| Associate data with the current filtered file.
EIO_API Eina_Bool | eio_file_associate_direct_add (Eio_File *ls, const char *key, const void *data, Eina_Free_Cb free_cb)
| Associate data with the current filtered file.
EIO_API void * | eio_file_associate_find (Eio_File *ls, const char *key)
| Get the data associated during the filter callback inside the main loop.

## Detailed Description

This are helper provided around core Eio API.

This set of functions do provide helper to work around data provided by Eio without the need to look at system header.

## Function Documentation

## ◆ eio_file_atime()

static double eio_file_atime | ( | const Eina_Stat * | st | ) |
| inlinestatic

Return last access time to a file.

Parameters

  st | The stat buffer as given by eio_file_stat callback.

Returns
  last access time.

This function return the st_atime field, last access time, as double like all EFL time call.

References _Eina_Stat::atime.

## ◆ eio_file_mtime()

static double eio_file_mtime | ( | const Eina_Stat * | st | ) |
| inlinestatic

Return last modification time of a file.

Parameters

  st | The stat buffer as given by eio_file_stat callback.

Returns
  last modification time.

This function return the st_mtime field, last modification time, as double like all EFL time call.

References _Eina_Stat::mtime.

## ◆ eio_file_size()

static long long eio_file_size | ( | const Eina_Stat * | st | ) |
| inlinestatic

Return file length.

Parameters

  st | The stat buffer as given by eio_file_stat callback.

Returns
  the length of a file.

This function is just an accessor to st_size and return the file length.

References _Eina_Stat::size.

## ◆ eio_file_is_dir()

static Eina_Bool eio_file_is_dir | ( | const Eina_Stat * | st | ) |
| inlinestatic

Return if path is a directory.

Parameters

  st | The stat buffer as given by eio_file_stat callback.

Returns
  EINA_TRUE if the path is a directory.

This function tell you if the stated path is a directory or not.

References EINA_FALSE, EINA_TRUE, and _Eina_Stat::mode.

## ◆ eio_file_is_lnk()

static Eina_Bool eio_file_is_lnk | ( | const Eina_Stat * | st | ) |
| inlinestatic

Return if path is a length.

Parameters

  st | The stat buffer as given by eio_file_stat callback.

Returns
  EINA_TRUE if the path is a length.

This function tell you if the stated path is a length or not.

Note
  On Windows, this function returns always EINA_FALSE.

References EINA_FALSE, EINA_TRUE, and _Eina_Stat::mode.

## ◆ eio_init()

EIO_API int eio_init | ( | void |  | ) |

Initialize eio and all its required submodule.

Returns
  the current number of eio users.

Examples
  eio_file_ls.c.

References ecore_init(), efreet_mime_init(), eina_init(), eina_log_domain_register(), eina_log_domain_unregister(), EINA_LOG_ERR, EINA_LOG_STATE_INIT, EINA_LOG_STATE_STOP, eina_log_timing(), and eina_shutdown().

Referenced by elm_quicklaunch_init().

## ◆ eio_shutdown()

EIO_API int eio_shutdown | ( | void |  | ) |

Shutdown eio and all its submodule if possible.

Returns
  the number of pending users of eio.

Examples
  eio_file_ls.c.

References ecore_shutdown(), ecore_thread_cancel(), ecore_thread_wait(), efreet_mime_shutdown(), EINA_LIST_FOREACH, EINA_LIST_FREE, eina_log_domain_unregister(), EINA_LOG_STATE_SHUTDOWN, EINA_LOG_STATE_START, eina_log_timing(), eina_shutdown(), and EINA_TRASH_CLEAN.

Referenced by elm_quicklaunch_init(), and elm_quicklaunch_shutdown().

## ◆ eio_memory_burst_limit_set()

EIO_API void eio_memory_burst_limit_set | ( | size_t | limit | ) |

Set the limit to the maximum amount of memory used.

Parameters

  limit | The actual limit to set.

Eio work by burst, allocating memory in a thread and moving it back to the main loop. This result in quite some huge memory usage if the main loop is to slow to cope with the speed of the thread. By setting this limit, the thread will block until enough memory has been freed to be below the limit again.

By default no limit is set and any value < 0 will mean no limit.

Note
  You should give at least a reasonable amount of memory or the thread might stall.

Since
  1.10

## ◆ eio_memory_burst_limit_get()

EIO_API size_t eio_memory_burst_limit_get | ( | void |  | ) |

Get the actual limit to the maximum amount of memory used.

Returns
  The current limit being set.

Since
  1.10

See also
  eio_memory_burst_limit_set

## ◆ eio_file_container_get()

EIO_API void * eio_file_container_get | ( | Eio_File * | ls | ) |

Return the container during EIO operation.

Parameters

  ls | The asynchronous I/O operation to retrieve container from.

Returns
  NULL if not available, a DIRP if it is.

This is only available and make sense in the thread callback, not in the mainloop.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ eio_file_cancel()

EIO_API Eina_Bool eio_file_cancel | ( | Eio_File * | ls | ) |

Cancel any Eio_File.

Parameters

  ls | The asynchronous I/O operation to cancel.

Returns
  EINA_FALSE if the destruction is delayed, EINA_TRUE if it's done.

This will cancel any kind of I/O operation and cleanup the mess. This means that it could take time to cancel an I/O.

References ecore_thread_cancel(), EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ eio_file_check()

EIO_API Eina_Bool eio_file_check | ( | Eio_File * | ls | ) |

Check if an Eio_File operation has been cancelled.

Parameters

  ls | The asynchronous I/O operation to check.

Returns
  EINA_TRUE if it was canceled, EINA_FALSE other wise.

In case of an error it also return EINA_TRUE.

References ecore_thread_check(), EINA_SAFETY_ON_NULL_RETURN_VAL, and EINA_TRUE.

## ◆ eio_file_associate_add()

EIO_API Eina_Bool eio_file_associate_add | ( | Eio_File * | ls,
|  | const char * | key,
|  | const void * | data,
|  | Eina_Free_Cb | free_cb
| ) |  |

Associate data with the current filtered file.

Parameters

  ls | The Eio_File ls request currently calling the filter callback.
  key | The key to associate data to.
  data | The data to associate the data to.
  free_cb | Optionally a function to call to free the associated data, `data` is passed as the callback data parameter. If no `free_cb` is provided the user `data` remains untouched.

Returns
  EINA_TRUE if insertion was fine.

This function can only be safely called from within the filter callback. If you don't need to copy the key around you can use eio_file_associate_direct_add

References EINA_FALSE, eina_hash_add(), eina_hash_string_small_new(), and EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ eio_file_associate_direct_add()

EIO_API Eina_Bool eio_file_associate_direct_add | ( | Eio_File * | ls,
|  | const char * | key,
|  | const void * | data,
|  | Eina_Free_Cb | free_cb
| ) |  |

Associate data with the current filtered file.

Parameters

  ls | The Eio_File ls request currently calling the filter callback.
  key | The key to associate data to (will not be copied, and the pointer will not be used as long as the file is not notified).
  data | The data to associate the data to.
  free_cb | The function to call to free the associated data, `free_cb` will be called if not specified.

Returns
  EINA_TRUE if insertion was fine.

This function can only be safely called from within the filter callback. If you need eio to make a proper copy of the `key` to be safe use eio_file_associate_add instead.

References EINA_FALSE, eina_hash_direct_add(), eina_hash_string_small_new(), and EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ eio_file_associate_find()

EIO_API void * eio_file_associate_find | ( | Eio_File * | ls,
|  | const char * | key
| ) |  |

Get the data associated during the filter callback inside the main loop.

Parameters

  ls | The Eio_File ls request currently calling the notify callback.
  key | The key pointing to the data to retrieve.

Returns
  the data associated with the key or `NULL` if not found.

References eina_hash_find(), and EINA_SAFETY_ON_NULL_RETURN_VAL.